#include<stdio.h>
#include<math.h>

main()
{
	int n, m, sum=0, mod=998244353;
	scanf("%i %i", &n, &m);
	int b[m+1];
	
	for(int i=1 ; i<=m ; ++i)
	{
		scanf("%i", &b[i]);
	}
	
	int a[n+1];
	
	for(int i=1 ; i<=n ; ++i)
	{
		a[i]=i;
	}
	
	for(int i=0 ; i<=(n-m) ; ++i)
	{
		for (int j=1; j<=m; j++) a[i + b[j]] = a[i + j];
	}
	
	long long int c;
	scanf("%lli", &c);
	
	for(int i=1 ; i<=n ; ++i)
	{
		sum+=fmod((pow(c , i) * a[i]),mod);
	}
	
	printf("%lli", sum);
}